   //Mit diesem Code klappt es jetzt, dass alle Motoren gleichzeitig angesteuert werden.
#include <Servo.h>
#define S2 10           //Pins für den Farbsensor
#define S3 11
#define sensorOUT 12
const int stepPinRechts = 3;  //Pins für die Räder.
const int dirPinRechts = 2;
const int stepPinLinks = 5;
const int dirPinLinks = 4;
Servo gelenk;//Servo der den Greifarm hoch-/runterfährt.
Servo greifer;//Greifmechanismus.
int stifte = 0;        //Variablen um die Anzahl der sich im Trichter befindenden Stifte/ die Position des Greifarms zu speichern:
int greifarmpos = 10;  //Position des Servomotors
int greifarmpos2 = 0;  //Position des Steppermotors
int greiferstatus = 90; //Status des Greif-Servos
int stepsmade = 0;      //speichert wie viele Schritte gemacht wurden
// Konstante für die Sensorkalibrierung :
int R_WHITE = 18;
int R_BLACK = 148;
int G_WHITE = 14;
int G_BLACK = 141;
int B_WHITE = 10;
int B_BLACK = 102;
int C_WHITE = 5;
int C_BLACK = 42;
//Variable zum Speichern der Stiftfarbe
bool GStift = false;
 

void setup() {
  Serial.begin(9600);
  pinMode(stepPinRechts, OUTPUT);
  pinMode(dirPinRechts, OUTPUT);
  pinMode(stepPinLinks, OUTPUT);
  pinMode(dirPinLinks, OUTPUT);
  pinMode(8, OUTPUT); //Step-Pin, Servo Greifarm.
  pinMode(9, OUTPUT); //Direction-Pin, Servo Greifarm.
  pinMode(A3, INPUT); //Infrarotsensor Kante.
  pinMode(A0, INPUT); //Transistor.
  pinMode(S2, OUTPUT);//Farbsensor.
  pinMode(S3, OUTPUT);
  gelenk.attach(10);
  greifer.attach(11);
  gelenk.write(greifarmpos);    //Arm fährt runter
  greifer.write(greiferstatus); //Greif-Servo wird geöffnet
  delay(1500);
  for(int i = 0;i<5;i++) {  //Der Greifarm wird in Position gebracht
    digitalWrite(9, HIGH);
    digitalWrite(8, HIGH);
    delayMicroseconds(7500);
    digitalWrite(8, LOW);
    delayMicroseconds(7500);
  }
}
// Ansteuerung des Farbsensors; Aufruf mit: 0 = "R", 1 = "G", 2 = "B", 3 = "C"
int sensorRead (int channel) {
  if (channel == 0 || channel == 2) {
    digitalWrite(S2, LOW);
  }
  else {
    digitalWrite(S2, HIGH);
  }
 
  if (channel == 0 || channel == 3) {
    digitalWrite(S3, LOW);
  }
  else {
    digitalWrite(S3, HIGH);
  }
 
 
  int valueSensor = pulseIn(sensorOUT, LOW);
  int rValue = map(valueSensor, R_BLACK, R_WHITE, 0, 255);
  int gValue = map(valueSensor, G_BLACK, G_WHITE, 0, 255);
  int bValue = map(valueSensor, B_BLACK, B_WHITE, 0, 255);
  int cValue = map(valueSensor, C_BLACK, C_WHITE, 0, 255);
  if(channel == 0) return rValue;
  if(channel == 1) return gValue;
  if(channel == 2) return bValue;
  if(channel == 3) return cValue;
}


void dir1 (void) {                       //Rückwärts
  digitalWrite(dirPinRechts, HIGH);
  digitalWrite(dirPinLinks, LOW);
}

void dir2 (void) {
  digitalWrite(dirPinRechts, LOW);     //Rückwärts
  digitalWrite(dirPinLinks, HIGH);
}

void fahren (int geschwindigkeit) {
  Serial.println(analogRead(A0)); 
  if (analogRead(A0) > 29 && greifarmpos == 10) {  //Kein Stift im Trichter.
    //gelenk.detach();
    //greifer.detach();
    stifte = 0;
  }
  if (analogRead(A0) < 29 && greifarmpos == 10) { // 1 Stift im Trichter
    stifte = 1;
    //gelenk.attach(A6);
    //greifer.attach(A7);
  }
  if (analogRead(A0) < 29 && greifarmpos >= 50) {  //1 Stift im Trichter, während der Greifarm noch am arbeiten ist.
    stifte = 2;
  }
  switch (stifte) {
    case (0):   //befindet sich kein Stift im Trichter bewegt sich der Roboter einfach vorwärts.
      digitalWrite(stepPinRechts, HIGH);
      digitalWrite(stepPinLinks, HIGH);
      delayMicroseconds(geschwindigkeit);
      digitalWrite(stepPinRechts, LOW);
      digitalWrite(stepPinLinks, LOW);
      delayMicroseconds(geschwindigkeit);
      
      break;


    case (1): //Befindet sich ein Stift im Trichter, bewegt sich der Roboter weiter vorwärts. Gleichzeitig beginnt auch der Greifarm mit dem Transportprozess.
      if (greifarmpos == 10 && greiferstatus == 90) {   //Abhängig davon in welcher Phase sich der Greifarm befindet, werden immer die Räder und ein Motor im Greifarm angesteuert.
        greiferstatus = 150;                            //der Stift wird ergriffen
        greifer.write(150);
        Serial.print("0==");
        Serial.println(sensorRead(0));
        Serial.print("1==");
        Serial.println(sensorRead(1));
        Serial.print("2==");
        Serial.println(sensorRead(2));
        Serial.print("3==");
        Serial.println(sensorRead(3));
        if(sensorRead(0) > 50 && sensorRead(1) < 211 && sensorRead(2) > 44 && sensorRead(3) < 0) GStift = true;    //Hier wird erkannt ob sich ein Grüner Stift im Trichter befindet
        else GStift = false;
        if(GStift==true) Serial.print("GSTIFT IST TRUE");
        for (int i = 0; i < 60; i++) {
          digitalWrite(stepPinRechts, HIGH);
          digitalWrite(stepPinLinks, HIGH);
          delayMicroseconds(geschwindigkeit);
          digitalWrite(stepPinRechts, LOW);
          digitalWrite(stepPinLinks, LOW);
          delayMicroseconds(geschwindigkeit);
          
          if(analogRead(A3) < 100) break;
          
        }

      }
      if (greifarmpos < 75 && greiferstatus == 150) {  //der Greifarm fährt hoch
        greifarmpos += 1;
        gelenk.write(greifarmpos);
        for (int i = 0 ; i < 3 ; i++) {
          digitalWrite(stepPinRechts, HIGH);
          digitalWrite(stepPinLinks, HIGH);
          delayMicroseconds(geschwindigkeit);
          digitalWrite(stepPinRechts, LOW);
          digitalWrite(stepPinLinks, LOW);
          delayMicroseconds(geschwindigkeit);
          
        }
      }
      if (greifarmpos == 75 && greiferstatus == 150 && greifarmpos2 < 100 && GStift == false) {  //es befindet sich kein Grüner Stift im Trichter, also fährt der Greifarm nur zum ersten Fach
        greifarmpos2 += 1;
        digitalWrite(9, LOW);
        digitalWrite(8, HIGH);
        digitalWrite(stepPinRechts, HIGH);
        digitalWrite(stepPinLinks, HIGH);
        delayMicroseconds(geschwindigkeit);
        digitalWrite(8, LOW);
        digitalWrite(stepPinRechts, LOW);
        digitalWrite(stepPinLinks, LOW);
        delayMicroseconds(geschwindigkeit);
         
      }
      if (greifarmpos == 75 && greiferstatus == 150 && greifarmpos2 < 111 && GStift == true) {  //es befindet sich ein Grüner Stift im Trichter, also fährt der Greifarm zum ersten Fach
        greifarmpos2 += 1;
        digitalWrite(9, LOW);
        digitalWrite(8, HIGH);
        digitalWrite(stepPinRechts, HIGH);
        digitalWrite(stepPinLinks, HIGH);
        delayMicroseconds(geschwindigkeit);
        digitalWrite(8, LOW);
        digitalWrite(stepPinRechts, LOW);
        digitalWrite(stepPinLinks, LOW);
        delayMicroseconds(geschwindigkeit);
        break;
         
      }
      if (greifarmpos == 75 && greiferstatus == 150 && greifarmpos2 == 100 && GStift == false) {
        for (int i = 0; i < 60; i++) {
          digitalWrite(stepPinRechts, HIGH);
          digitalWrite(stepPinLinks, HIGH);
          delayMicroseconds(geschwindigkeit);
          digitalWrite(stepPinRechts, LOW);
          digitalWrite(stepPinLinks, LOW);
          delayMicroseconds(geschwindigkeit);
          
          if(analogRead(A3) < 100) break;
        }
        greiferstatus = 90;                              //der Stift wird in das Fach fallen gelassen
        greifer.write(90);
        for (int i = 0; i < 60; i++) {
          digitalWrite(stepPinRechts, HIGH);
          digitalWrite(stepPinLinks, HIGH);
          delayMicroseconds(geschwindigkeit);
          digitalWrite(stepPinRechts, LOW);
          digitalWrite(stepPinLinks, LOW);
          delayMicroseconds(geschwindigkeit);
          
          if(analogRead(A3) < 100) break;
        }
      }
       if (greifarmpos == 75 && greiferstatus == 150 && greifarmpos2 == 111 && GStift == true) {
        for (int i = 0; i < 60; i++) {
          digitalWrite(stepPinRechts, HIGH);
          digitalWrite(stepPinLinks, HIGH);
          delayMicroseconds(geschwindigkeit);
          digitalWrite(stepPinRechts, LOW);
          digitalWrite(stepPinLinks, LOW);
          delayMicroseconds(geschwindigkeit);
          
          if(analogRead(A3) < 100) break;
        }
        greiferstatus = 90;
        greifer.write(90);
        for (int i = 0; i < 60; i++) {
          digitalWrite(stepPinRechts, HIGH);
          digitalWrite(stepPinLinks, HIGH);
          delayMicroseconds(geschwindigkeit);
          digitalWrite(stepPinRechts, LOW);
          digitalWrite(stepPinLinks, LOW);
          delayMicroseconds(geschwindigkeit);
          
          if(analogRead(A3) < 100) break;
        }
      }
      if (greifarmpos == 75 && greiferstatus == 90 && greifarmpos2 > 0) {   // der Greifarm dreht sich zurück
        greifarmpos2 -= 1;
        digitalWrite(9, HIGH);
        digitalWrite(8, HIGH);
        digitalWrite(stepPinRechts, HIGH);
        digitalWrite(stepPinLinks, HIGH);
        delayMicroseconds(geschwindigkeit);
        digitalWrite(8, LOW);
        digitalWrite(stepPinRechts, LOW);
        digitalWrite(stepPinLinks, LOW);
        delayMicroseconds(geschwindigkeit);
        
      }
      if (greifarmpos > 10 && greiferstatus == 90 && greifarmpos2 == 0) {  //der Greifarm fährt runter, in die Ausgangsposition
        greifarmpos -= 1;
        gelenk.write(greifarmpos);
        for (int i = 0 ; i < 3 ; i++) {
          digitalWrite(stepPinRechts, HIGH);
          digitalWrite(stepPinLinks, HIGH);
          delayMicroseconds(geschwindigkeit);
          digitalWrite(stepPinRechts, LOW);
          digitalWrite(stepPinLinks, LOW);
          delayMicroseconds(geschwindigkeit);
          
        }
      }

      break;
    case (2):
     if (greifarmpos == 10 && greiferstatus == 90) {   //Abhängig davon in welcher Phase sich der Greifarm befindet, werden immer die Räder und ein Motor im Greifarm angesteuert.
        delay(500);
        if(sensorRead(0) > 50 && sensorRead(1) < 211 && sensorRead(2) > 44 && sensorRead(3) < 0) GStift = true;
        else GStift = false;
        greiferstatus = 150;
        greifer.write(150);
        delay(500);

      }
      if (greifarmpos < 75 && greiferstatus == 150) {
        greifarmpos += 1;
        gelenk.write(greifarmpos);
        delay(30);
      }
      if (greifarmpos == 75 && greiferstatus == 150 && greifarmpos2 < 100 && GStift == false) {
        greifarmpos2 += 1;
        digitalWrite(9, LOW);
        digitalWrite(8, HIGH);
        
        delayMicroseconds(geschwindigkeit);
        digitalWrite(8, LOW);
        
        delayMicroseconds(geschwindigkeit);
      }
       if (greifarmpos == 75 && greiferstatus == 150 && greifarmpos2 < 111 && GStift == true) {
        greifarmpos2 += 1;
        digitalWrite(9, LOW);
        digitalWrite(8, HIGH);
        
        delayMicroseconds(geschwindigkeit);
        digitalWrite(8, LOW);
        
        delayMicroseconds(geschwindigkeit);
        break;
      }
      if (greifarmpos == 75 && greiferstatus == 150 && (greifarmpos2 == 100 || greifarmpos2 == 111)) {
        delay(750);
        greiferstatus = 90;
        greifer.write(90);
        delay(750);
        
      }
      if (greifarmpos == 75 && greiferstatus == 90 && greifarmpos2 > 0) {
        greifarmpos2 -= 1;
        digitalWrite(9, HIGH);
        digitalWrite(8, HIGH);
       
        delayMicroseconds(geschwindigkeit);
        digitalWrite(8, LOW);
       
        delayMicroseconds(geschwindigkeit);
      }
      if (greifarmpos > 10 && greiferstatus == 90 && greifarmpos2 == 0) {
        greifarmpos -= 1;
        gelenk.write(greifarmpos);
        delay(30);
        if (greifarmpos==10) {
          delay(750);
        }
       }
       break;
       
      
  }

}


void turnR (int geschwindigkeit) {   //90 Grad drehung nach rechts
  stepsmade = 0; //Schritte werden zurückgesetzt
  
  digitalWrite(dirPinRechts, LOW);
  digitalWrite(dirPinLinks, LOW);
 //der code für die turnR, die turnL und die fahren2 Methode, ist der code aus der fahren Methode, nur mit verschiedenen kleinen Anpassungen
  while(stepsmade < 133) {                   //133 Schritte entsprechen 90 Grad
    //Serial.println(analogRead(A0));
    if (analogRead(A0) > 29 && greifarmpos == 10) {  //Kein Stift im Trichter.
    //gelenk.detach();
    //greifer.detach();
    stifte = 0;
  }
  if (analogRead(A0) < 29 && greifarmpos == 10) { // 1 Stift im Trichter
    stifte = 1;
    //gelenk.attach(A6);
    //greifer.attach(A7);
  }
  if (analogRead(A0) < 29 && greifarmpos >= 50) {  //1 Stift im Trichter, während der Greifarm noch am arbeiten ist.
    stifte = 2;
  }
  switch (stifte) {
    case (0):   //befindet sich kein Stift im Trichter bewegt sich der Roboter einfach vorwärts.
      digitalWrite(stepPinRechts, HIGH);
      digitalWrite(stepPinLinks, HIGH); 
      delayMicroseconds(geschwindigkeit);
      digitalWrite(stepPinRechts, LOW);
      digitalWrite(stepPinLinks, LOW);
      delayMicroseconds(geschwindigkeit);
      stepsmade += 1;
      break;


    case (1): //Befindet sich ein Stift im Trichter, bewegt sich der Roboter weiter vorwärts. Gleichzeitig beginnt auch der Greifarm mit dem Transportprozess.
      if (greifarmpos == 10 && greiferstatus == 90) {   //Abhängig davon in welcher Phase sich der Greifarm befindet, werden immer die Räder und ein Motor im Greifarm angesteuert.
        greiferstatus = 150;
        greifer.write(150);
        if(sensorRead(0) > 50 && sensorRead(1) < 211 && sensorRead(2) > 44 && sensorRead(3) < 0) GStift = true;
        else GStift = false;
        for (int i = 0; i < 60; i++) {
          digitalWrite(stepPinRechts, HIGH);
          digitalWrite(stepPinLinks, HIGH);
          delayMicroseconds(geschwindigkeit);
          digitalWrite(stepPinRechts, LOW);
          digitalWrite(stepPinLinks, LOW);
          delayMicroseconds(geschwindigkeit);
          stepsmade += 1;
          if(stepsmade >= 133) break;              //falls 133 Schritte gemacht wurden wird die Schleife unterbrochen, damit nicht zu viele Schritte gemacht werden, da das die Drehung beinflussen würde
         
          
        }
        

      }
      if (greifarmpos < 75 && greiferstatus == 150) {
        greifarmpos += 1;
        gelenk.write(greifarmpos);
        for (int i = 0 ; i < 3 ; i++) {
          digitalWrite(stepPinRechts, HIGH);
          digitalWrite(stepPinLinks, HIGH);
          delayMicroseconds(geschwindigkeit);
          digitalWrite(stepPinRechts, LOW);
          digitalWrite(stepPinLinks, LOW);
          delayMicroseconds(geschwindigkeit);
          stepsmade += 1;
          if(stepsmade >= 133) break;
        }
      }
      if (greifarmpos == 75 && greiferstatus == 150 && greifarmpos2 < 100 && GStift == false) {
        greifarmpos2 += 1;
        digitalWrite(9, LOW);
        digitalWrite(8, HIGH);
        digitalWrite(stepPinRechts, HIGH);
        digitalWrite(stepPinLinks, HIGH);
        delayMicroseconds(geschwindigkeit);
        digitalWrite(8, LOW);
        digitalWrite(stepPinRechts, LOW);
        digitalWrite(stepPinLinks, LOW);
        delayMicroseconds(geschwindigkeit);
        stepsmade += 1;
         
      }
      if (greifarmpos == 75 && greiferstatus == 150 && greifarmpos2 < 111 && GStift == true) {
        greifarmpos2 += 1;
        digitalWrite(9, LOW);
        digitalWrite(8, HIGH);
        digitalWrite(stepPinRechts, HIGH);
        digitalWrite(stepPinLinks, HIGH);
        delayMicroseconds(geschwindigkeit);
        digitalWrite(8, LOW);
        digitalWrite(stepPinRechts, LOW);
        digitalWrite(stepPinLinks, LOW);
        delayMicroseconds(geschwindigkeit);
        stepsmade += 1;
        break;
         
      }
      if (greifarmpos == 75 && greiferstatus == 150 && (greifarmpos2 == 100 || greifarmpos2 == 111)) {
        for (int i = 0; i < 60; i++) {
          digitalWrite(stepPinRechts, HIGH);
          digitalWrite(stepPinLinks, HIGH);
          delayMicroseconds(geschwindigkeit);
          digitalWrite(stepPinRechts, LOW);
          digitalWrite(stepPinLinks, LOW);
          delayMicroseconds(geschwindigkeit);
          stepsmade += 1;
          if(stepsmade >= 133) break;
         
        }
        greiferstatus = 90;
        greifer.write(90);
        for (int i = 0; i < 60; i++) {
          digitalWrite(stepPinRechts, HIGH);
          digitalWrite(stepPinLinks, HIGH);
          delayMicroseconds(geschwindigkeit);
          digitalWrite(stepPinRechts, LOW);
          digitalWrite(stepPinLinks, LOW);
          delayMicroseconds(geschwindigkeit);
          stepsmade += 1;
          if(stepsmade >= 133) break;
          
        }
      }
      if (greifarmpos == 75 && greiferstatus == 90 && greifarmpos2 > 0) {
        greifarmpos2 -= 1;
        digitalWrite(9, HIGH);
        digitalWrite(8, HIGH);
        digitalWrite(stepPinRechts, HIGH);
        digitalWrite(stepPinLinks, HIGH);
        delayMicroseconds(geschwindigkeit);
        digitalWrite(8, LOW);
        digitalWrite(stepPinRechts, LOW);
        digitalWrite(stepPinLinks, LOW);
        delayMicroseconds(geschwindigkeit);
        stepsmade += 1;
        
      }
      if (greifarmpos > 10 && greiferstatus == 90 && greifarmpos2 == 0) {
        greifarmpos -= 1;
        gelenk.write(greifarmpos);
        for (int i = 0 ; i < 3 ; i++) {
          digitalWrite(stepPinRechts, HIGH);
          digitalWrite(stepPinLinks, HIGH);
          delayMicroseconds(geschwindigkeit);
          digitalWrite(stepPinRechts, LOW);
          digitalWrite(stepPinLinks, LOW);
          delayMicroseconds(geschwindigkeit);
          stepsmade += 1;
          if(stepsmade >= 133) break;
        }
      }

      break;
    case (2):
     if (greifarmpos == 10 && greiferstatus == 90) {   //Abhängig davon in welcher Phase sich der Greifarm befindet, werden immer die Räder und ein Motor im Greifarm angesteuert.
        delay(500);
        greiferstatus = 150;
        greifer.write(150);
        if(sensorRead(0) > 50 && sensorRead(1) < 211 && sensorRead(2) > 44 && sensorRead(3) < 0) GStift = true;
        else GStift = false;
        delay(500);

      }
      if (greifarmpos < 75 && greiferstatus == 150) {
        greifarmpos += 1;
        gelenk.write(greifarmpos);
        delay(30);
      }
      if (greifarmpos == 75 && greiferstatus == 150 && greifarmpos2 < 100 && GStift == false) {
        greifarmpos2 += 1;
        digitalWrite(9, LOW);
        digitalWrite(8, HIGH);
        
        delayMicroseconds(geschwindigkeit);
        digitalWrite(8, LOW);
        
        delayMicroseconds(geschwindigkeit);
      }
       if (greifarmpos == 75 && greiferstatus == 150 && greifarmpos2 < 111 && GStift == true) {
        greifarmpos2 += 1;
        digitalWrite(9, LOW);
        digitalWrite(8, HIGH);
        
        delayMicroseconds(geschwindigkeit);
        digitalWrite(8, LOW);
        
        delayMicroseconds(geschwindigkeit);
        break;
      }
      if (greifarmpos == 75 && greiferstatus == 150 && (greifarmpos2 == 100 || greifarmpos2 == 111)) {
        delay(750);
        greiferstatus = 90;
        greifer.write(90);
        delay(750);
        
      }
      if (greifarmpos == 75 && greiferstatus == 90 && greifarmpos2 > 0) {
        greifarmpos2 -= 1;
        digitalWrite(9, HIGH);
        digitalWrite(8, HIGH);
       
        delayMicroseconds(geschwindigkeit);
        digitalWrite(8, LOW);
       
        delayMicroseconds(geschwindigkeit);
      }
      if (greifarmpos > 10 && greiferstatus == 90 && greifarmpos2 == 0) {
        greifarmpos -= 1;
        gelenk.write(greifarmpos);
        delay(30);
         if (greifarmpos==10) {
          delay(750);
        }
       }
       break;
       
      
  }

}

  
  dir2();


}
void turnL (int geschwindigkeit) {  // eigentlich wie turnR
  stepsmade = 0;
  
  digitalWrite(dirPinRechts, HIGH);
  digitalWrite(dirPinLinks, HIGH);
 
  while(stepsmade < 133) {
    Serial.println(analogRead(A0));
    if (analogRead(A0) > 29 && greifarmpos == 10) {  //Kein Stift im Trichter.
    //gelenk.detach();
    //greifer.detach();
    stifte = 0;
  }
  if (analogRead(A0) < 29 && greifarmpos == 10) { // 1 Stift im Trichter
    stifte = 1;
    //gelenk.attach(A6);
    //greifer.attach(A7);
  }
  if (analogRead(A0) < 29 && greifarmpos >= 50) {  //1 Stift im Trichter, während der Greifarm noch am arbeiten ist.
    stifte = 2;
  }
  switch (stifte) {
    case (0):   //befindet sich kein Stift im Trichter bewegt sich der Roboter einfach vorwärts.
      digitalWrite(stepPinRechts, HIGH);
      digitalWrite(stepPinLinks, HIGH);
      delayMicroseconds(geschwindigkeit);
      digitalWrite(stepPinRechts, LOW);
      digitalWrite(stepPinLinks, LOW);
      delayMicroseconds(geschwindigkeit);
      stepsmade += 1;
      break;


    case (1): //Befindet sich ein Stift im Trichter, bewegt sich der Roboter weiter vorwärts. Gleichzeitig beginnt auch der Greifarm mit dem Transportprozess.
      if (greifarmpos == 10 && greiferstatus == 90) {   //Abhängig davon in welcher Phase sich der Greifarm befindet, werden immer die Räder und ein Motor im Greifarm angesteuert.
        greiferstatus = 150;
        greifer.write(150);
        if(sensorRead(0) > 50 && sensorRead(1) < 211 && sensorRead(2) > 44 && sensorRead(3) < 0) GStift = true;
        else GStift = false;
        for (int i = 0; i < 60; i++) {
          digitalWrite(stepPinRechts, HIGH);
          digitalWrite(stepPinLinks, HIGH);
          delayMicroseconds(geschwindigkeit);
          digitalWrite(stepPinRechts, LOW);
          digitalWrite(stepPinLinks, LOW);
          delayMicroseconds(geschwindigkeit);
          stepsmade += 1;
          if(stepsmade >= 133) break;
         
          
        }
        

      }
      if (greifarmpos < 75 && greiferstatus == 150) {
        greifarmpos += 1;
        gelenk.write(greifarmpos);
        for (int i = 0 ; i < 3 ; i++) {
          digitalWrite(stepPinRechts, HIGH);
          digitalWrite(stepPinLinks, HIGH);
          delayMicroseconds(geschwindigkeit);
          digitalWrite(stepPinRechts, LOW);
          digitalWrite(stepPinLinks, LOW);
          delayMicroseconds(geschwindigkeit);
          stepsmade += 1;
          if(stepsmade >= 133) break;
        }
      }
      if (greifarmpos == 75 && greiferstatus == 150 && greifarmpos2 < 100 && GStift == false) {
        greifarmpos2 += 1;
        digitalWrite(9, LOW);
        digitalWrite(8, HIGH);
        digitalWrite(stepPinRechts, HIGH);
        digitalWrite(stepPinLinks, HIGH);
        delayMicroseconds(geschwindigkeit);
        digitalWrite(8, LOW);
        digitalWrite(stepPinRechts, LOW);
        digitalWrite(stepPinLinks, LOW);
        delayMicroseconds(geschwindigkeit);
        stepsmade += 1;
         
      }
      if (greifarmpos == 75 && greiferstatus == 150 && greifarmpos2 < 111 && GStift == true) {
        greifarmpos2 += 1;
        digitalWrite(9, LOW);
        digitalWrite(8, HIGH);
        digitalWrite(stepPinRechts, HIGH);
        digitalWrite(stepPinLinks, HIGH);
        delayMicroseconds(geschwindigkeit);
        digitalWrite(8, LOW);
        digitalWrite(stepPinRechts, LOW);
        digitalWrite(stepPinLinks, LOW);
        delayMicroseconds(geschwindigkeit);
        stepsmade += 1;
        break;
         
      }
      if (greifarmpos == 75 && greiferstatus == 150 && (greifarmpos2 == 100 || greifarmpos2 == 111)) {
        for (int i = 0; i < 60; i++) {
          digitalWrite(stepPinRechts, HIGH);
          digitalWrite(stepPinLinks, HIGH);
          delayMicroseconds(geschwindigkeit);
          digitalWrite(stepPinRechts, LOW);
          digitalWrite(stepPinLinks, LOW);
          delayMicroseconds(geschwindigkeit);
          stepsmade += 1;
          if(stepsmade >= 133) break;
         
        }
        greiferstatus = 90;
        greifer.write(90);
        for (int i = 0; i < 60; i++) {
          digitalWrite(stepPinRechts, HIGH);
          digitalWrite(stepPinLinks, HIGH);
          delayMicroseconds(geschwindigkeit);
          digitalWrite(stepPinRechts, LOW);
          digitalWrite(stepPinLinks, LOW);
          delayMicroseconds(geschwindigkeit);
          stepsmade += 1;
          if(stepsmade >= 133) break;
          
        }
      }
      if (greifarmpos == 75 && greiferstatus == 90 && greifarmpos2 > 0) {
        greifarmpos2 -= 1;
        digitalWrite(9, HIGH);
        digitalWrite(8, HIGH);
        digitalWrite(stepPinRechts, HIGH);
        digitalWrite(stepPinLinks, HIGH);
        delayMicroseconds(geschwindigkeit);
        digitalWrite(8, LOW);
        digitalWrite(stepPinRechts, LOW);
        digitalWrite(stepPinLinks, LOW);
        delayMicroseconds(geschwindigkeit);
        stepsmade += 1;
        
      }
      if (greifarmpos > 10 && greiferstatus == 90 && greifarmpos2 == 0) {
        greifarmpos -= 1;
        gelenk.write(greifarmpos);
        for (int i = 0 ; i < 3 ; i++) {
          digitalWrite(stepPinRechts, HIGH);
          digitalWrite(stepPinLinks, HIGH);
          delayMicroseconds(geschwindigkeit);
          digitalWrite(stepPinRechts, LOW);
          digitalWrite(stepPinLinks, LOW);
          delayMicroseconds(geschwindigkeit);
          stepsmade += 1;
          if(stepsmade >= 133) break;
        }
      }

      break;
    case (2):
     if (greifarmpos == 10 && greiferstatus == 90) {   //Abhängig davon in welcher Phase sich der Greifarm befindet, werden immer die Räder und ein Motor im Greifarm angesteuert.
        delay(500);
        greiferstatus = 150;
        greifer.write(150);
        if(sensorRead(0) > 50 && sensorRead(1) < 211 && sensorRead(2) > 44 && sensorRead(3) < 0) GStift = true;
        else GStift = false;
        delay(500);

      }
      if (greifarmpos < 75 && greiferstatus == 150) {
        greifarmpos += 1;
        gelenk.write(greifarmpos);
        delay(30);
      }
      if (greifarmpos == 75 && greiferstatus == 150 && greifarmpos2 < 100 && GStift == false) {
        greifarmpos2 += 1;
        digitalWrite(9, LOW);
        digitalWrite(8, HIGH);
        
        delayMicroseconds(geschwindigkeit);
        digitalWrite(8, LOW);
        
        delayMicroseconds(geschwindigkeit);
      }
       if (greifarmpos == 75 && greiferstatus == 150 && greifarmpos2 < 111 && GStift == true) {
        greifarmpos2 += 1;
        digitalWrite(9, LOW);
        digitalWrite(8, HIGH);
        
        delayMicroseconds(geschwindigkeit);
        digitalWrite(8, LOW);
        
        delayMicroseconds(geschwindigkeit);
        break;
      }
      if (greifarmpos == 75 && greiferstatus == 150 && (greifarmpos2 == 100 || greifarmpos2 == 111)) {
        delay(750);
        greiferstatus = 90;
        greifer.write(90);
        delay(750);
        
      }
      if (greifarmpos == 75 && greiferstatus == 90 && greifarmpos2 > 0) {
        greifarmpos2 -= 1;
        digitalWrite(9, HIGH);
        digitalWrite(8, HIGH);
       
        delayMicroseconds(geschwindigkeit);
        digitalWrite(8, LOW);
       
        delayMicroseconds(geschwindigkeit);
      }
      if (greifarmpos > 10 && greiferstatus == 90 && greifarmpos2 == 0) {
        greifarmpos -= 1;
        gelenk.write(greifarmpos);
        delay(30);
         if (greifarmpos==10) {
          delay(750);
        }
       }
       break;
       
      
  }

}

  
  dir2();


}




void beschleunigen () {     //lässt den Roboter langsam anfahren
  int c = 7500;
  for (int i = 0; i < 200; i++) {

    fahren(c);
    c -= 7,5;

  }
}



void fahren2 (int geschwindigkeit, int steps) {     // Methode um nur eine bestimmte Distanz zu fahren
  stepsmade = 0;
  bool ende = false;                                //ist bool end==true, ist der Roboter fertig
  while(stepsmade < steps) {
    
  if (analogRead(A0) > 29 && greifarmpos == 10) {  //Kein Stift im Trichter.
    //gelenk.detach();
    //greifer.detach();
    stifte = 0;
  }
  if (analogRead(A0) < 29 && greifarmpos == 10) { // 1 Stift im Trichter
    stifte = 1;
    //gelenk.attach(A6);
    //greifer.attach(A7);
    Serial.println("fahren2");
  }
  if (analogRead(A0) < 29 && greifarmpos >= 50) {  //1 Stift im Trichter, während der Greifarm noch am arbeiten ist.
    stifte = 2;
  }
  if(analogRead(A3) < 100) {
      bool ende = true;
      stifte = 2;
    }
  switch (stifte) {
    case (0):   //befindet sich kein Stift im Trichter bewegt sich der Roboter einfach vorwärts.
      digitalWrite(stepPinRechts, HIGH);
      digitalWrite(stepPinLinks, HIGH);
      delayMicroseconds(geschwindigkeit);
      digitalWrite(stepPinRechts, LOW);
      digitalWrite(stepPinLinks, LOW);
      delayMicroseconds(geschwindigkeit);
      stepsmade += 1;
      break;


    case (1): //Befindet sich ein Stift im Trichter, bewegt sich der Roboter weiter vorwärts. Gleichzeitig beginnt auch der Greifarm mit dem Transportprozess.
      if (greifarmpos == 10 && greiferstatus == 90) {   //Abhängig davon in welcher Phase sich der Greifarm befindet, werden immer die Räder und ein Motor im Greifarm angesteuert.
        greiferstatus = 150;
        greifer.write(150);
        if(sensorRead(0) > 50 && sensorRead(1) < 211 && sensorRead(2) > 44 && sensorRead(3) < 0) GStift = true;
        else GStift = false;
        for (int i = 0; i < 60; i++) {
          digitalWrite(stepPinRechts, HIGH);
          digitalWrite(stepPinLinks, HIGH);
          delayMicroseconds(geschwindigkeit);
          digitalWrite(stepPinRechts, LOW);
          digitalWrite(stepPinLinks, LOW);
          delayMicroseconds(geschwindigkeit);
          stepsmade += 1;
          if(stepsmade >= steps) break;
          if(analogRead(A3) < 100) break;
         
          
        }

      }
      if (greifarmpos < 75 && greiferstatus == 150) {
        greifarmpos += 1;
        gelenk.write(greifarmpos);
        for (int i = 0 ; i < 3 ; i++) {
          digitalWrite(stepPinRechts, HIGH);
          digitalWrite(stepPinLinks, HIGH);
          delayMicroseconds(geschwindigkeit);
          digitalWrite(stepPinRechts, LOW);
          digitalWrite(stepPinLinks, LOW);
          delayMicroseconds(geschwindigkeit);
          stepsmade += 1;
          if(stepsmade >= steps) break;
          
        }
      }
      if (greifarmpos == 75 && greiferstatus == 150 && greifarmpos2 < 100 && GStift == false) {
        greifarmpos2 += 1;
        digitalWrite(9, LOW);
        digitalWrite(8, HIGH);
        digitalWrite(stepPinRechts, HIGH);
        digitalWrite(stepPinLinks, HIGH);
        delayMicroseconds(geschwindigkeit);
        digitalWrite(8, LOW);
        digitalWrite(stepPinRechts, LOW);
        digitalWrite(stepPinLinks, LOW);
        delayMicroseconds(geschwindigkeit);
        stepsmade += 1;
         
      }
      if (greifarmpos == 75 && greiferstatus == 150 && greifarmpos2 < 111 && GStift == true) {
        greifarmpos2 += 1;
        digitalWrite(9, LOW);
        digitalWrite(8, HIGH);
        digitalWrite(stepPinRechts, HIGH);
        digitalWrite(stepPinLinks, HIGH);
        delayMicroseconds(geschwindigkeit);
        digitalWrite(8, LOW);
        digitalWrite(stepPinRechts, LOW);
        digitalWrite(stepPinLinks, LOW);
        delayMicroseconds(geschwindigkeit);
        stepsmade += 1;
        break;
         
      }
      if (greifarmpos == 75 && greiferstatus == 150 && (greifarmpos2 == 100 || greifarmpos2 == 111)) {
        for (int i = 0; i < 60; i++) {
          digitalWrite(stepPinRechts, HIGH);
          digitalWrite(stepPinLinks, HIGH);
          delayMicroseconds(geschwindigkeit);
          digitalWrite(stepPinRechts, LOW);
          digitalWrite(stepPinLinks, LOW);
          delayMicroseconds(geschwindigkeit);
          stepsmade += 1;
          if(stepsmade >= steps) break;
          if(analogRead(A3) < 100) break;
         
        }
        greiferstatus = 90;
        greifer.write(90);
        for (int i = 0; i < 60; i++) {
          digitalWrite(stepPinRechts, HIGH);
          digitalWrite(stepPinLinks, HIGH);
          delayMicroseconds(geschwindigkeit);
          digitalWrite(stepPinRechts, LOW);
          digitalWrite(stepPinLinks, LOW);
          delayMicroseconds(geschwindigkeit);
          stepsmade += 1;
          if(stepsmade >= steps) break;
          if(analogRead(A3) < 100) break;
          
        }
      }
      if (greifarmpos == 75 && greiferstatus == 90 && greifarmpos2 > 0) {
        greifarmpos2 -= 1;
        digitalWrite(9, HIGH);
        digitalWrite(8, HIGH);
        digitalWrite(stepPinRechts, HIGH);
        digitalWrite(stepPinLinks, HIGH);
        delayMicroseconds(geschwindigkeit);
        digitalWrite(8, LOW);
        digitalWrite(stepPinRechts, LOW);
        digitalWrite(stepPinLinks, LOW);
        delayMicroseconds(geschwindigkeit);
        stepsmade += 1;
        
      }
      if (greifarmpos > 10 && greiferstatus == 90 && greifarmpos2 == 0) {
        greifarmpos -= 1;
        gelenk.write(greifarmpos);
        for (int i = 0 ; i < 3 ; i++) {
          digitalWrite(stepPinRechts, HIGH);
          digitalWrite(stepPinLinks, HIGH);
          delayMicroseconds(geschwindigkeit);
          digitalWrite(stepPinRechts, LOW);
          digitalWrite(stepPinLinks, LOW);
          delayMicroseconds(geschwindigkeit);
          stepsmade += 1;
          if(stepsmade >= steps) break;
          
        }
      }

      break;
    case (2):
     if (greifarmpos == 10 && greiferstatus == 90) {   //Abhängig davon in welcher Phase sich der Greifarm befindet, werden immer die Räder und ein Motor im Greifarm angesteuert.
        delay(500);
        greiferstatus = 150;
        greifer.write(150);
        if(sensorRead(0) > 50 && sensorRead(1) < 211 && sensorRead(2) > 44 && sensorRead(3) < 0) GStift = true;
        else GStift = false;

        delay(500);

      }
      if (greifarmpos < 75 && greiferstatus == 150) {
        greifarmpos += 1;
        gelenk.write(greifarmpos);
        delay(30);
      }
      if (greifarmpos == 75 && greiferstatus == 150 && greifarmpos2 < 100 && GStift == false) {
        greifarmpos2 += 1;
        digitalWrite(9, LOW);
        digitalWrite(8, HIGH);
        
        delayMicroseconds(geschwindigkeit);
        digitalWrite(8, LOW);
        
        delayMicroseconds(geschwindigkeit);
      }
       if (greifarmpos == 75 && greiferstatus == 150 && greifarmpos2 < 111 && GStift == true) {
        greifarmpos2 += 1;
        digitalWrite(9, LOW);
        digitalWrite(8, HIGH);
        
        delayMicroseconds(geschwindigkeit);
        digitalWrite(8, LOW);
        
        delayMicroseconds(geschwindigkeit);
        break;  
      }
      if (greifarmpos == 75 && greiferstatus == 150 && (greifarmpos2 == 100 || greifarmpos2 == 111) ) {
        delay(750);
        greiferstatus = 90;
        greifer.write(90);
        delay(750);
        if(ende == true) {
          gelenk.detach();
          greifer.detach();
          for(int i = 0; i > 1; i=i) {
            delay(10000);
          }
        }
        
      }
      if (greifarmpos == 75 && greiferstatus == 90 && greifarmpos2 > 0) {
        greifarmpos2 -= 1;
        digitalWrite(9, HIGH);
        digitalWrite(8, HIGH);
       
        delayMicroseconds(geschwindigkeit);
        digitalWrite(8, LOW);
       
        delayMicroseconds(geschwindigkeit);
      }
      if (greifarmpos > 10 && greiferstatus == 90 && greifarmpos2 == 0) {
        greifarmpos -= 1;
        gelenk.write(greifarmpos);
        delay(30);
         if (greifarmpos==10) {
          delay(750);
        }
       }
       break;
       
      
  }

}
}





void loop() {

  //Hier werden nur noch die einzelnen Funktionen aufgerufen, was zum in der Dokumentation beschriebenen Ablauf führt.
  dir2 ();
  beschleunigen();

  while (analogRead(A3) > 100) { 
    
    fahren(6000);
     

  }
  delay(1000);

  turnR(6500);

  delay(1000);

  fahren2(6500, 135);

  delay(1000);

  turnR(6500);

  delay(1000);

  beschleunigen();
  while (analogRead(A3) > 100) {
    fahren(6000);
  }

  delay(1000);

  turnL(6500);

  delay(1000);

  fahren2(6500, 135);

  delay(1000);

  turnL(6500);










  
}





